/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.client;

import java.io.*;
import gnu.getopt.*;
import javax.swing.*;
import java.awt.event.*;

import gdistasi.StarzaNet.client.*;
import gdistasi.StarzaNet.server.*;
import gdistasi.StarzaNet.server.MySocket;
import gdistasi.StarzaNet.server.Environment;


public class Main implements GestoreFinLogin {
    Connetti finConnetti;
    Connessione connessione;
    ConnessioneTestuale connTesto;
    Getopt g;
    boolean indOk;
    boolean autoConnect;
    
     
    public Main(String[] argc){
	connTesto=new ConnessioneTestuale();
	g=new Getopt("starzaclient",argc,"s:m:u:ac");
    }


    public void leggiFile() throws IOException,ConfException {
	Conf conf=new Conf(Environment.getFileClient(),Conf.TYPE_OLD);
	try {
	    Environment.SERVER=conf.trova("server");
	    connTesto.setServer(Environment.SERVER);
	    indOk=true;
	} catch (IOException e){
	    System.err.println(e);
	    } 
    }
    
    public void autentica(String user, char[] pass){
	finConnetti.setVisible(false);
	connessione=new Connessione(user,pass);
    }
    
    public void start() throws IOException {
	/*	try {
	    leggiFile();
	} catch (IOException e) {
	    System.err.println(e+" problema nel caricamento di "+ Environment.getFileClient());
	    System.exit(2);
	} catch (ConfException e){
	    System.err.println(e);
	    System.exit(1);
	} 
	*/
	 
	int c;
	String arg;
	while ((c = g.getopt()) != -1){
	    switch(c){
	    case 's':
		arg = g.getOptarg();
		Environment.SERVER=arg;
		indOk=true;
		connTesto.setServer(arg);
		break;
		//
	    case 'a':
		connTesto.setAutoConnect(true);
		break;
	    case 'u':
		connTesto.setUser(g.getOptarg());
		break;

	    case 'm':
		connTesto.setMinuti(g.getOptarg());
		break;
	    case 'c':
		connTesto.setReqConnessi();
		break;

	    case '?':
		break; // getopt() already printed an error
		//
	    default:
		System.out.print("getopt() returned " + c + "\n");
	    }
	    
	}
	
	if (indOk){
	    if (connTesto.isPronto()){
		connTesto.start();
	    } else {
		finConnetti=new Connetti(this);
		finConnetti.show();
	    }
	} else { 
	    visualizzaErrore("Indica con l\' opzione della riga di comando \"s\" l'indirizzo ip del server\n es. \"-s indirizzo\"");
	    System.exit(1);
	    
		
	}
    }

    public void exit(){
	System.exit(0);
    }
    
    public void visualizzaErrore(String errore){
	
	if (!connTesto.isPronto())
	JOptionPane.showMessageDialog(
				      null,
				      errore,
				      "Errore",
				      
				      JOptionPane.ERROR_MESSAGE,
				      null
  		    );
	System.err.println("Errore: "+errore);
    }


    public static void main(String argc[]) throws IOException,ConfException {
	Main m=new Main(argc);
	
	m.start();

    }
}










