/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.client.bacheca;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.*;
import gdistasi.StarzaNet.client.*;
import gdistasi.StarzaNet.client.comandi.*;
import gdistasi.StarzaNet.server.bacheca.*;


public class Bacheca extends WindowAdapter implements Runnable {
    WinBacheca winBacheca;
    GestoreComandiClient gestore;
    SocketClient socket;
    ArrayList messaggi;
    Thread thread;
    ModelloLista modello;

    public Bacheca(GestoreComandiClient gestore,SocketClient socket){
	this.gestore=gestore;
	this.socket=socket;
	thread=new Thread(this);
	//	modello=new ModelloLista();
	messaggi=new ArrayList();
	winBacheca=new WinBacheca(this);
	thread.run();
    }

    public synchronized void addMessaggio(String testo){
	Messaggio msg=new Messaggio(testo);

	ComandoInviaMessaggio comando=new ComandoInviaMessaggio(msg);
	gestore.esegui(comando);

	caricaMessaggi();
    }

    public void caricaMessaggi(){
	//	modello.clear();
	winBacheca.getTextArea().setText("");

	ComandoRiceviMessaggi comando=new ComandoRiceviMessaggi();
	gestore.esegui(comando);
    }

    public void run(){
	//caricaMessaggi();
	//	winBacheca.setModelloLista(modello);
    }

    public void windowClosing(WindowEvent e){
	winBacheca.dispose();
    }

    public void aggiungiMessaggi(ArrayList ar){
	Iterator i=ar.iterator();
	String msg;
	while(i.hasNext()){
	    msg=i.next().toString();
	    winBacheca.getTextArea().append(msg+"\n");
	}
    }
    
    public void visualizza(){	
	caricaMessaggi();
	winBacheca.setVisible(true);
    }


} 





