/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.client.help;


import javax.swing.*;
import java.awt.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.io.*;

import gdistasi.StarzaNet.server.Environment;

public class AboutBox extends JDialog
{
  public AboutBox(Frame owner) {
    super(owner, "About StarzaNet", true);

    JLabel lbl = new JLabel(new ImageIcon("icon.gif"));
    JPanel p = new JPanel();
    Border b1 = new BevelBorder(BevelBorder.LOWERED);
    Border b2 = new EmptyBorder(5, 5, 5, 5);
    lbl.setBorder(new CompoundBorder(b1, b2));
    p.add(lbl);
    getContentPane().add(p, BorderLayout.WEST);



    String message = "StarzaNet Client "+Environment.VERSION+"\n"+
	"Copyright 2002 Giovanni Di Stasi\n\n" ;

    StringBuffer licenza = new StringBuffer(caricaMessaggio());

    licenza.insert(0,message);
    
    JTextArea txt = new JTextArea(licenza.toString());
    txt.setBorder(new EmptyBorder(5, 10, 5, 10));
    txt.setFont(new Font("Helvetica", Font.BOLD, 12));
    txt.setEditable(false);
    txt.setBackground(getBackground());
    p = new JPanel();
    p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
    p.add(txt);

    message = "\n"+
      "";
    txt = new JTextArea(message);
    txt.setBorder(new EmptyBorder(5, 10, 5, 10));
    txt.setFont(new Font("Arial", Font.PLAIN, 12));
    txt.setEditable(false);
    txt.setBackground(getBackground());
    p.add(txt);
        
    getContentPane().add(p, BorderLayout.CENTER);

    JButton btOK = new JButton("OK");
    ActionListener lst = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
        setVisible(false);
      }
    };
    btOK.addActionListener(lst);
    p = new JPanel();
    p.add(btOK);
    getContentPane().add(p, BorderLayout.SOUTH);

    pack();
    setResizable(false);
  }

    public String caricaMessaggio(){
	String ret=new String("");
	
	try {

	    File file = new File(Environment.FILE_LICENZA);
	    
	    BufferedReader reader = new BufferedReader(
	       new InputStreamReader(new FileInputStream(file),"ISO-8859-1"));
	    
	    StringBuffer buf=new StringBuffer((int)file.length());
	    
	    String letto;
	    while ((letto=reader.readLine())!=null)
		buf.append(letto+"\n");
	
	    ret = buf.toString();
	} catch (IOException e) {
	    System.err.println("Errore in caricamento licenza "+ e);
	}

	return ret;
    }


}




