/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server;

import java.net.*;
import java.io.*;
import java.util.logging.*;

import gdistasi.StarzaNet.server.*;
import gdistasi.StarzaNet.server.bacheca.*;
import gdistasi.StarzaNet.server.comandi.*;
import gdistasi.util.*;




public class ConsolleComandi {
    protected MySocket socket;
    protected Utente utente;
    protected GestoreComandi gestoreComandi;
    protected int esito;
    Logger log;

    static public final String MESSAGGIO="messaggio";
    static public final String RICEVI_MESSAGGI="ricevi_msg";
    static public final String CONNESSI="connessi";
    static public final String PROSPETTO="prospetto";
    static public final String ATTESACOMANDO="Comando: ";
    static public final String DATIGENERALI="dammi i dati generali";
    static public final String SUCCESSO="OK";
    static public final String DATI="dammi i dati";
    static public final String CONNETTI="connetti";
    static public final String DISCONNETTI="disconnetti";
    static public final String TIMEOUT="timeout";
    static public final String INFO="info";
    static public final String STOP="stop";

    static final String[] errori=new String[30];
    static {
	errori[1]="Comando non riconosciuto";
	errori[0]="OK";
	errori[2]="Utente gia connesso";
	errori[3]="errore3";
	errori[4]="utente non risulta collegato";
	errori[5]="err. in connessione ad internet. Consultare l'amministratore";
	errori[6]="errore nello stop della connessione... staccare a mano la presetta ISDN e consultare gianni";
	errori[9]="errore in avvio connessione ad internet";
	errori[10]="utente non connesso";
    }



    public ConsolleComandi(MySocket socket,GestoreComandi gestoreComandi,Utente utente){
	this.socket=socket;
	this.utente=utente;
	this.gestoreComandi=gestoreComandi;
	this.log=Environment.getLogger();
    }

    public void attendiComandi() throws IOException {
	int intComando;
	Comando comando=null;
	boolean stop=false;

	socket.writeLine(Login.loginCorretto);
	
	try {
	    while (!stop) {
		intComando=socket.readInt();
		comando=gestoreComandi.riconosciComando(intComando);
		if (comando!=null) {
	     		preparaEdEsegui(comando);	
		}
		else {
		    //socket.close();
		    log.severe("Comando non riconosciuto: "+comando);
		}
	    }
	} catch (EOFException e){
	    log.log(Level.INFO,"Connection closed from user: "+utente.toString());
	    //	    e.printStackTrace();
	} catch (IOException e){
	    //e.printStackTrace();
	} finally {
	    //	    System.err.println("Stavo eseguendo: "+comando);
	    cleanupConnessione();
	    //socket.close();
	}
    }
	
	
	
    public void preparaEdEsegui(Comando comando) throws IOException {
	comando.setUtente(utente);
	comando.setSocket(socket);
	gestoreComandi.esegui(comando);
    }

    
    public void cleanupConnessione() throws IOException {
	
    }

    public void riportaEsito(){
	socket.writeLine(errori[esito]);
    }

    public String leggiComando() throws ConnessioneCaduta {
	String comando;
	comando=socket.readLine();
	
	return comando;
    }


    /*
    public void stampaComandi(){
	for (int i=0; i<comandi.length; i++){
	    socket.writeLine(comandi[i]);

	}
	}*/

}
































































































































