/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server;

import org.xml.sax.*;
import java.util.logging.*;


public class ErrorHandlerMy implements ErrorHandler {
    Logger log;

    public ErrorHandlerMy(Logger log){
	this.log=log;
    }


    public void error(SAXParseException e) throws SAXException { 
	log.log(Level.SEVERE,e.getMessage()+"\nParsing error: line "+ e.getLineNumber()+" in column "+
		e.getColumnNumber());
	System.exit(5);
    }


    public void fatalError(SAXParseException e) throws SAXException {
	error(e);
    }


    public void warning(SAXParseException e) throws SAXException {
	error(e);
    }




}
