/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */


package gdistasi.StarzaNet.server;

import org.w3c.dom.*;
import java.net.*;

public class Firewall{
    String[] masq;
    String[] demasq;
    String[] forward;
    String[] deforward;

    public Firewall(Node firewall){
	NodeList list=firewall.getChildNodes();
	Node n;
        for (int i=0; i<list.getLength(); i++){
	    n=list.item(i);
	    if (n.getNodeName().equals("masq")){
		masq=Conf.parseString(n.getFirstChild().getNodeValue());
	    } else if (n.getNodeName().equals("demasq")){
		demasq=Conf.parseString(n.getFirstChild().getNodeValue());
	    } else if (n.getNodeName().equals("forward")){
		forward=Conf.parseString(n.getFirstChild().getNodeValue());
	    } else if (n.getNodeName().equals("deforward")){
		deforward=Conf.parseString(n.getFirstChild().getNodeValue());
	    }
	    
	}
	    
    }

    public String[] forward(InetAddress IP){
	String[] ret=(String[])forward.clone();
	
	for (int i=0; i< ret.length; i++){
	    if (ret[i].equals("$IP")) ret[i]=IP.getHostAddress();
	}

	Util.esegui(ret);

	return ret;
    }

    public String[] deforward(InetAddress IP){
	String[] ret=new String[deforward.length];
	int i;

	for (i=0; i< ret.length; i++){
	    if (deforward[i].equals("$IP")) ret[i]=IP.getHostAddress();
	    else ret[i]=deforward[i];
	}
	
	Util.esegui(ret);

	return ret;
    }

    public String[] masq(InetAddress IP){
	String[] ret= (String[])masq.clone();
	
	for (int i=0; i< ret.length; i++){
	    if (ret[i].equals("$IP")) ret[i]=IP.getHostAddress();
	}

	Util.esegui(ret);
	return ret;
    }    

    public String[] demasq(InetAddress IP){
	String[] ret=(String[])demasq.clone();
	
	for (int i=0; i< ret.length; i++){
	    if (ret[i].equals("$IP")) ret[i]=IP.getHostAddress();
	}
	Util.esegui(ret);

	return ret;
    }




}
