/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server;



import gnu.getopt.*;
import gdistasi.util.Consolle;
import gdistasi.StarzaNet.server.*;
import gdistasi.StarzaNet.server.gestione.*;

import java.io.*;
import java.util.*;

public class Starzacfg {
    LettoreConf lett;
    Getopt g;
    ArrayList utenti;
    Selezionatore selezionatore;
    Main main;
    
    public Starzacfg() throws Exception {
	utenti=new ArrayList(5);
	selezionatore=new Selezionatore();
	main= new Main();
    }

    


    public static void main(String[] arg) throws Exception {

	

	try {

	    Starzacfg m=new Starzacfg();
	    m.main.leggiFile(false);
	    m.lett=new LettoreConf(Environment.getFileUtenti(),"SHA");
	    m.init(arg);

	} catch (Exception e){
	    System.err.println(e.getMessage());
	}
	
	
    }

    public void init(String[] args) throws IOException {
	g=new Getopt("starzacfg",args,"a:u:m:d:");

	int c;
	String arg;
	while ((c = g.getopt()) != -1){
	    switch(c){
	    case 'a':
		arg = g.getOptarg();
		cambiaPass(arg);
		break;
		//
	    case 'd':
		arg = g.getOptarg();
		Environment.debug=Integer.parseInt(arg);
		break;

	    case 'u':
		addUtente(g.getOptarg());
		break;
	    case 'm':
		selezionatore.addCriterioMese(g.getOptarg());
		//System.out.println(g.getOptarg());
		break;

	    case '?':
		break; // getopt() already printed an error
		//
	    default:
		System.out.print("getopt() returned " + c + "\n");
	    }

	}
	
	if (utenti.size()>0){
	    stampaRiepilogo();
	    //	    System.out.println(utenti.size());
	}	
    }

    void addUtente(String utente){
	utenti.add(utente);
    }

    void stampaRiepilogo(){
	Bolletta bolletta=new Bolletta(selezionatore);
	//	System.out.println("bolletta");
	//	System.out.println(utenti);
	bolletta.stampaUtenti(utenti);
    }
    
    
    void cambiaPass(String user) throws IOException {
	String pass;
	
	System.out.println("Inserisci password: ");
	pass=Consolle.readString();
	System.out.println("Confermi l'operazione (si o no)?");
	
	
	if (Consolle.readString().toLowerCase().equals("si"))
	    lett.aggiungiUtente(user,pass);
	
	
    }
	

}


