/*
 *	Copyright (C) 2002, Giovanni Di Stasi	giovannidistasi@libero.it
 *
 *	This file is part of 'starzanet'
 *
 *	See the file called "LICENSE" for license information.
 */

package gdistasi.StarzaNet.server.comandi;


import gdistasi.StarzaNet.server.*;
import gdistasi.StarzaNet.server.bacheca.*;
import java.io.*;

public class GestoreComandi {
    protected Connessione connessione;
    protected Bacheca bacheca;
    protected LettoreConf lettoreConf;

    public GestoreComandi(Connessione connessione,Bacheca bacheca,LettoreConf lett){
	this.connessione=connessione;
	this.bacheca=bacheca;
	this.lettoreConf=lett;
	//	System.out.println(this.getClass().getName());
    }

    public Connessione getConnessione(){
	return connessione;
    }

    public synchronized int esegui(Comando comando){
	int ris=0;
	MySocket socket=null;
	
	try {
	    //System.out.println("Eseguo: "+comando.toString());
	    comando.setGestoreParteServer(this);
	    comando.esegui();
	    
	} catch (IOException e){
	       System.err.println(e+" in esecuzione comando");
	} finally {
	    
	}
	
	return ris;  
    }

    public Bacheca getBacheca(){
	return bacheca;
    }

    public void cambiaPass(Utente utente,String vecchia,String nuova) throws PassException,IOException {
	lettoreConf.cambiaPass(utente.toString(),vecchia,nuova);
    }



    public Comando riconosciComando(int comando){
	Comando ret=null;

	if (comando==1) ret=new ComandoDati();
	if (comando==2) ret=new ComandoConnessi();
	if (comando==3) ret=new ComandoConnetti();
	if (comando==4) ret=new ComandoDisconnetti();
	if (comando==5) ret = new ComandoTimeout();
	if (comando==6) ret = new ComandoProspetto();
	if (comando==7) ret = new ComandoMillis();
	if (comando==8) ret = new ComandoInviaMessaggio();
	if (comando==9) ret = new ComandoRiceviMessaggi();
	if (comando==10) ret= new ComandoCambiaPassword();

	return ret;
    }


}
